/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the GoogleCampaignManagerConnectorForm type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GoogleCampaignManagerConnectorForm{}

// GoogleCampaignManagerConnectorForm struct for GoogleCampaignManagerConnectorForm
type GoogleCampaignManagerConnectorForm struct {
	ConnectorId string `json:"connectorId"`
	TemplateId  string `json:"templateId"`
	Strategy    string `json:"strategy"`
	// Enforcing data types
	EnsureDataTypes map[string]interface{} `json:"ensureDataTypes,omitempty"`
	// Authorizer ID
	OAuthId string `json:"oAuthId"`
	// Label of the source
	Label *string `json:"label,omitempty"`
	// Amazon Ads Profile ID
	ProfileId string `json:"profileId"`
	// Amazon Ads Report Type
	ReportType string `json:"reportType"`
	// Data range expression
	DateRangeExpression string `json:"dateRangeExpression"`
}

// NewGoogleCampaignManagerConnectorForm instantiates a new GoogleCampaignManagerConnectorForm object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGoogleCampaignManagerConnectorForm(connectorId string, templateId string, strategy string, oAuthId string, profileId string, reportType string, dateRangeExpression string) *GoogleCampaignManagerConnectorForm {
	this := GoogleCampaignManagerConnectorForm{}
	this.ConnectorId = connectorId
	this.TemplateId = templateId
	this.Strategy = strategy
	this.OAuthId = oAuthId
	this.ProfileId = profileId
	this.ReportType = reportType
	this.DateRangeExpression = dateRangeExpression
	return &this
}

// NewGoogleCampaignManagerConnectorFormWithDefaults instantiates a new GoogleCampaignManagerConnectorForm object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGoogleCampaignManagerConnectorFormWithDefaults() *GoogleCampaignManagerConnectorForm {
	this := GoogleCampaignManagerConnectorForm{}
	return &this
}

// GetConnectorId returns the ConnectorId field value
func (o *GoogleCampaignManagerConnectorForm) GetConnectorId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConnectorId
}

// GetConnectorIdOk returns a tuple with the ConnectorId field value
// and a boolean to check if the value has been set.
func (o *GoogleCampaignManagerConnectorForm) GetConnectorIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConnectorId, true
}

// SetConnectorId sets field value
func (o *GoogleCampaignManagerConnectorForm) SetConnectorId(v string) {
	o.ConnectorId = v
}

// GetTemplateId returns the TemplateId field value
func (o *GoogleCampaignManagerConnectorForm) GetTemplateId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TemplateId
}

// GetTemplateIdOk returns a tuple with the TemplateId field value
// and a boolean to check if the value has been set.
func (o *GoogleCampaignManagerConnectorForm) GetTemplateIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TemplateId, true
}

// SetTemplateId sets field value
func (o *GoogleCampaignManagerConnectorForm) SetTemplateId(v string) {
	o.TemplateId = v
}

// GetStrategy returns the Strategy field value
func (o *GoogleCampaignManagerConnectorForm) GetStrategy() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Strategy
}

// GetStrategyOk returns a tuple with the Strategy field value
// and a boolean to check if the value has been set.
func (o *GoogleCampaignManagerConnectorForm) GetStrategyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Strategy, true
}

// SetStrategy sets field value
func (o *GoogleCampaignManagerConnectorForm) SetStrategy(v string) {
	o.Strategy = v
}

// GetEnsureDataTypes returns the EnsureDataTypes field value if set, zero value otherwise.
func (o *GoogleCampaignManagerConnectorForm) GetEnsureDataTypes() map[string]interface{} {
	if o == nil || IsNil(o.EnsureDataTypes) {
		var ret map[string]interface{}
		return ret
	}
	return o.EnsureDataTypes
}

// GetEnsureDataTypesOk returns a tuple with the EnsureDataTypes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleCampaignManagerConnectorForm) GetEnsureDataTypesOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.EnsureDataTypes) {
		return map[string]interface{}{}, false
	}
	return o.EnsureDataTypes, true
}

// HasEnsureDataTypes returns a boolean if a field has been set.
func (o *GoogleCampaignManagerConnectorForm) HasEnsureDataTypes() bool {
	if o != nil && !IsNil(o.EnsureDataTypes) {
		return true
	}

	return false
}

// SetEnsureDataTypes gets a reference to the given map[string]interface{} and assigns it to the EnsureDataTypes field.
func (o *GoogleCampaignManagerConnectorForm) SetEnsureDataTypes(v map[string]interface{}) {
	o.EnsureDataTypes = v
}

// GetOAuthId returns the OAuthId field value
func (o *GoogleCampaignManagerConnectorForm) GetOAuthId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value
// and a boolean to check if the value has been set.
func (o *GoogleCampaignManagerConnectorForm) GetOAuthIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OAuthId, true
}

// SetOAuthId sets field value
func (o *GoogleCampaignManagerConnectorForm) SetOAuthId(v string) {
	o.OAuthId = v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *GoogleCampaignManagerConnectorForm) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleCampaignManagerConnectorForm) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *GoogleCampaignManagerConnectorForm) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *GoogleCampaignManagerConnectorForm) SetLabel(v string) {
	o.Label = &v
}

// GetProfileId returns the ProfileId field value
func (o *GoogleCampaignManagerConnectorForm) GetProfileId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ProfileId
}

// GetProfileIdOk returns a tuple with the ProfileId field value
// and a boolean to check if the value has been set.
func (o *GoogleCampaignManagerConnectorForm) GetProfileIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ProfileId, true
}

// SetProfileId sets field value
func (o *GoogleCampaignManagerConnectorForm) SetProfileId(v string) {
	o.ProfileId = v
}

// GetReportType returns the ReportType field value
func (o *GoogleCampaignManagerConnectorForm) GetReportType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ReportType
}

// GetReportTypeOk returns a tuple with the ReportType field value
// and a boolean to check if the value has been set.
func (o *GoogleCampaignManagerConnectorForm) GetReportTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ReportType, true
}

// SetReportType sets field value
func (o *GoogleCampaignManagerConnectorForm) SetReportType(v string) {
	o.ReportType = v
}

// GetDateRangeExpression returns the DateRangeExpression field value
func (o *GoogleCampaignManagerConnectorForm) GetDateRangeExpression() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.DateRangeExpression
}

// GetDateRangeExpressionOk returns a tuple with the DateRangeExpression field value
// and a boolean to check if the value has been set.
func (o *GoogleCampaignManagerConnectorForm) GetDateRangeExpressionOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.DateRangeExpression, true
}

// SetDateRangeExpression sets field value
func (o *GoogleCampaignManagerConnectorForm) SetDateRangeExpression(v string) {
	o.DateRangeExpression = v
}

func (o GoogleCampaignManagerConnectorForm) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GoogleCampaignManagerConnectorForm) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["connectorId"] = o.ConnectorId
	toSerialize["templateId"] = o.TemplateId
	toSerialize["strategy"] = o.Strategy
	if !IsNil(o.EnsureDataTypes) {
		toSerialize["ensureDataTypes"] = o.EnsureDataTypes
	}
	toSerialize["oAuthId"] = o.OAuthId
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	toSerialize["profileId"] = o.ProfileId
	toSerialize["reportType"] = o.ReportType
	toSerialize["dateRangeExpression"] = o.DateRangeExpression
	return toSerialize, nil
}

type NullableGoogleCampaignManagerConnectorForm struct {
	value *GoogleCampaignManagerConnectorForm
	isSet bool
}

func (v NullableGoogleCampaignManagerConnectorForm) Get() *GoogleCampaignManagerConnectorForm {
	return v.value
}

func (v *NullableGoogleCampaignManagerConnectorForm) Set(val *GoogleCampaignManagerConnectorForm) {
	v.value = val
	v.isSet = true
}

func (v NullableGoogleCampaignManagerConnectorForm) IsSet() bool {
	return v.isSet
}

func (v *NullableGoogleCampaignManagerConnectorForm) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGoogleCampaignManagerConnectorForm(val *GoogleCampaignManagerConnectorForm) *NullableGoogleCampaignManagerConnectorForm {
	return &NullableGoogleCampaignManagerConnectorForm{value: val, isSet: true}
}

func (v NullableGoogleCampaignManagerConnectorForm) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGoogleCampaignManagerConnectorForm) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
